; Disassembly by MK
; See example_bas for demo of use

        include 'dev8_keys_sys'
        include 'dev8_keys_sbasic'
        include 'dev8_keys_chn'
        include 'dev8_keys_qlv'
        include 'dev8_keys_qdos_sms'
        include 'dev8_keys_qdos_pt'
        include 'dev8_keys_qdos_io'
        include 'dev8_keys_err'

        section code

        xdef WM_Rptr
        xdef WM_Outln
        xdef WM_Sptr
        xdef WM_wrsp
        xdef input_edit
        xdef dnr
        xdef fwind
        xdef tqueue


; QLIB data block
qchid   equ     $0010           ; Channel ID
qptrrec equ     $0014           ; WM.RPTR pointer record
qptrwin equ     $001A           ; ?
;       equ     $002C
qptrpos equ     $0034           ; Pointer position

; WM_Rptr #chan, term, xpos%, ypos%, keystroke%
WM_Rptr
        movea.l a5,a0
        suba.l  a3,a0
        cmpa.l  #5*8,a0                 ; 5 parameters
          bne   err_nimp
        bsr     gt_chan
          bne   rp_rts
        movea.l sb_cheap(a6),a4         ; QLIB data pointer?
        move.l  d7,qchid(a4)
        moveq   #-1,d3
        moveq   #iop.pinf,d0
        movea.l qchid(a4),a0
        trap    #3
        tst.l   d0
          bne   err_nimp
        move.l  a1,d0
          beq.s err_nimp
        movea.l a3,a5
        addq.l  #8,a5
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s rp_rts
        movea.l sb_arthp(a6),a1
        move.l  (a6,a1.l),d2            ; Param2 = termination vector
        addq.l  #8,a3
        lea     qptrrec(a4),a1
        move.l  qptrpos(a4),d1
        moveq   #-1,d3
        moveq   #iop.rptr,d0
        trap    #3
        move.l  d1,qptrpos(a4)
        tst.b   d2                      ; Window request (move/size)?
          bpl.s wp_normal               ; ... no, normal read
        move.l  d1,qptrrec+pp_xpos(a4)  ; window position is absolute position
        bra.s   wp_data

wp_normal
        move.l  qchid(a4),d0
        cmp.l   qptrrec+pp_chid(a4),d0  ; hit in our window?
          beq.s wp_data
        move.l  #-1,qptrwin(a4)         ; ... no, invalidate position
wp_data
        movea.l nt_value(a6,a3.l),a2
        adda.l  sb_datab(a6),a2
        move.w  qptrrec+pp_xpos(a4),(a6,a2.l)   ; 3rd var = xpos
        addq.l  #8,a3
        movea.l nt_value(a6,a3.l),a2
        adda.l  sb_datab(a6),a2
        move.w  qptrrec+pp_ypos(a4),(a6,a2.l)   ; 4th var = ypos
        addq.l  #8,a3
        movea.l nt_value(a6,a3.l),a2
        adda.l  sb_datab(a6),a2
        moveq   #0,d0
        move.b  qptrrec+pp_kstrk(a4),d0
        move.w  d0,(a6,a2.l)                    ; 5th var = keystroke
        moveq   #0,d0
rp_rts  rts
;
err_nimp
        moveq   #err.nimp,d0
        rts

; WM_Sptr #chan, xpos, ypos
;
; Set mouse position relative to window
WM_Sptr
        bsr     gt_chan
          bne.s sp_rts
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s sp_rts
        cmpi.w  #2,d3                   ; two more parameters
          bne   err_ipar
        movea.l sb_arthp(a6),a1
        movea.l d7,a0
        moveq   #-1,d3
        moveq   #1,d2                   ; relative to hit area
        move.w  $02(a6,a1.l),d1         ; xpos
        swap    d1
        move.w  $06(a6,a1.l),d1         ; ypos
        moveq   #iop.sptr,d0
        trap    #3
sp_rts  rts

; WM_Wrsp #chan, xpos, ypos, sprite-ptr
;
; Draw sprite into window
WM_Wrsp
        bsr     gt_chan
          bne.s sp_rts
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s wr_rts
        cmpi.w  #3,d3                   ; three more parameters
          bne.s err_ipar
        movea.l sb_arthp(a6),a1
        movea.l d7,a0
        moveq   #-1,d3
        move.w  $02(a6,a1.l),d1         ; xpos
        swap    d1
        move.w  $06(a6,a1.l),d1         ; ypos
        movea.l $08(a6,a1.l),a1         ; pointer to sprite definition
        moveq   #iop.wspt,d0
        trap    #3
wr_rts  rts

; WM_Outln #chan, x-size, y-size, x-origin, y-origin, x-shadow, y-shadow
;
; Set managed outline
WM_Outln
        bsr     gt_chan
          bne.s ou_rts
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s ou_rts
        cmpi.w  #6,d3                   ; six additional parameters
          bne.s err_ipar
        movea.l sb_arthp(a6),a1
        movea.l sb_buffb(a6),a2         ; input buffer as scratch area
        moveq   #5,d3
ou_loop
        move.w  2(a6,a1.l),0(a6,a2.l)   ; compact LONG to WORD
        addq.l  #4,a1
        addq.l  #2,a2
        dbf     d3,ou_loop
        movea.l d7,a0                   ; channel ID
        movea.l (a6),a1                 ; window definition block
        moveq   #-1,d3
        moveq   #0,d2                   ; clear contents
        move.l  8(a6,a1.l),d1           ; shadow x/y
        moveq   #iop.outl,d0
        trap    #4
        trap    #3
ou_rts  rts
;
err_ipar
        moveq   #err.ipar,d0
        rts

; Input_edit$ #chan, max-len, string
;
; Edit existing string
input_edit
        bsr     gt_chan
          bne.s inp_rts
        movea.l a3,a5
        addq.l  #8,a5                   ; get one long int
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s inp_rts

        movea.l sb_arthp(a6),a1
        move.l  (a6,a1.l),d2            ; get max length
        addq.l  #8,a3                   ; next param is string to edit
        movea.l nt_value(a6,a3.l),a2
        adda.l  sb_datab(a6),a2
        moveq   #0,d1
        move.w  (a6,a2.l),d1            ; string length
        movea.l sb_buffb(a6),a1         ; input buffer
        addq.l  #2,a1
        addq.l  #2,a2
        move.w  d1,d0
        bra.s   inp_copy_start          ; copy into input buffer

inp_copy
        move.b  (a6,a2.l),(a6,a1.l)
        addq.l  #1,a1
        addq.l  #1,a2
inp_copy_start
        dbf     d0,inp_copy

        movea.l d7,a0                   ; channel ID
        moveq   #-1,d3
        moveq   #iob.elin,d0
        trap    #4
        trap    #3
        move.l  d1,d2                   ; new line length

        moveq   #iow.dcur,d0            ; disable cursors
        trap    #3

        movea.l sb_buffb(a6),a1
        subq.w  #1,d2                   ; set line length
        move.w  d2,(a6,a1.l)

        move.l  a1,sb_arthp(a6)
        movea.w sb.putp,a2              ; put string parameter
        jsr     (a2)
        moveq   #0,d0
inp_rts rts

; win = Fwind(xpos, ypos, window-count, window-int-array (xsize, ysize, xpos, ypos, ?, ?, ?, ?, ?, ?))
fwind   movea.l a5,a0
        suba.l  a3,a0
        moveq   #err.ipar,d0
        cmpa.l  #4*8,a0                 ; Need 4 parameters
          bne.s fw_rts
        movea.l a5,a4
        movea.l a3,a5
        adda.w  #3*8,a5                 ; First 3 parameters are integers
        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s fw_rts

        movea.l sb_arthp(a6),a1
        move.l  0(a6,a1.l),d4           ; xpos in d4
        move.l  4(a6,a1.l),d5           ; ypos in d5
        move.l  8(a6,a1.l),d3           ; window cound in d3
        adda.w  #3*8,a3
        movea.l nt_value(a6,a3.l),a1
        adda.l  sb_datab(a6),a1
        movea.l 0(a6,a1.l),a1           ; ? array contents
        adda.l  sb_datab(a6),a1
        moveq   #1,d6                   ; window index
        bra.s   fw_start

fw_loop
        move.w  4(a6,a1.l),d0           ; xpos of window
        cmp.w   d0,d4
          bcs.s fw_next                 ; outside
        add.w   0(a6,a1.l),d0           ; xsize
        cmp.w   d0,d4
          bcc.s fw_next
        move.w  6(a6,a1.l),d0           ; ypos
        cmp.w   d0,d5
          bcs.s fw_next
        add.w   2(a6,a1.l),d0           ; ysize
        cmp.w   d0,d5
          bcc.s fw_next
        bra.s   fw_retint

fw_next
        addq.l  #1,d6
fw_start
        adda.w  #2*10,a1
        dbf     d3,fw_loop
        moveq   #-1,d6                  ; no window found
fw_retint
        movea.l sb_arthp(a6),a1
        move.w  d6,(a6,a1.l)
        moveq   #3,d4                   ; return integer
        moveq   #0,d0
fw_rts  rts

; isqueue = Tqueue #chan
;
; Is current keyboard queue within specified channel defintion block (0/1)
tqueue
        bsr.s   gt_chan
          bne.s tq_rts
        moveq   #sms.info,d0
        trap    #1

        movea.l sys_chtb(a0),a2
        lsl.w   #2,d7
        movea.l (a2,d7.w),a2            ; channel address
        movea.l a2,a3
        adda.l  chn_len(a2),a3          ; end of CDB
        moveq   #0,d6
        cmpa.l  sys_ckyq(a0),a2
          bcc.s tq_no
        cmpa.l  sys_ckyq(a0),a3
          bcs.s tq_no
        moveq   #1,d6
tq_no   bra.s   fw_retint
tq_rts  rts

; Dnr #chan, word
;
; Output word value at 0,0
dnr     bsr.s   gt_chan
          bne.s dnr_rts

        movea.w sb.gtlin,a2
        jsr     (a2)
          bne.s dnr_rts

        movea.l sb_arthp(a6),a1
        addq.l  #2,a1
        movea.l sb_buffb(a6),a0         ; temp buffer
        movea.w cv.iwdec,a2             ; word to decimal
        jsr     (a2)
        suba.l  sb_buffb(a6),a0         ; length of string

        move.l  a0,d5                   ; remember length
        moveq   #0,d1                   ; column 0
        moveq   #0,d2                   ; row 0
        moveq   #0,d3                   ; timeout
        movea.l d7,a0                   ; channel-id
        moveq   #iow.scur,d0            ; set cursor to 0,0
        trap    #3
        tst.l   d0
          bne.s dnr_ok

        movea.l sb_buffb(a6),a1         ; converted string
        move.l  d5,d2                   ; length
        moveq   #iob.smul,d0            ; output
        trap    #4
        trap    #3
dnr_ok  moveq   #0,d0
dnr_rts rts
;
gt_chan
        movem.l d1-d6/a0-a2,-(a7)
        btst    #7,1(a6,a3.l)           ; Hash?
          beq.s gc_ipar                 ; ... no
        move.l  a5,-(a7)
        movea.l a3,a5
        addq.l  #8,a5
        movea.w sb.gtlin,a2
        jsr     (a2)
        movea.l (a7)+,a5
          bne.s gc_ipar
        addq.l  #8,a3                   ; Remove parameter
        move.l  (a6,a1.l),d7
        bsr.s   L036A                   ; Get channel id in d7
          bne.s gc_ipar
        moveq   #0,d0
        bra.s   gc_rts
gc_ipar
        moveq   #err.ipar,d0
gc_rts  movem.l (a7)+,d1-d6/a0-a2
        rts
;
L036A   moveq   #ch.len,d1
        mulu.w  d1,d7
        movea.l sb_chanb(a6),a2
        adda.l  d7,a2
        cmpa.l  sb_chanp(a6),a2
          bge.s err_ichn
        move.l  ch_chid(a6,a2.l),d7
        moveq   #0,d0
ok      tst.b   d0
        rts
;
err_ichn
        moveq   #err.ichn,d0
        bra.s   ok

        end
