* SCRXY
*
* V0.01,  pjwitte 2oi8
* V0.02, pjw, June 5th 2019, check parameters, now Qdos+PI compatible?
* V0.03, pjw, 2021 Oct 03, if no PI return "standard" sizes
*

        section code

        xdef SCRXY

        include dev8_keys_con
        include dev8_keys_sys
        include dev8_keys_sbasic
        include dev8_keys_qdos_sms
        include dev8_keys_qlv
        include dev8_keys_err


*
SCRXY
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get screen dimensions directly from screen driver - without use of
* a channel
*
* SCRXY sx%, sy%
*
* where sx%/sy% are return parameters
*
* Only programmer parameter errors
*

        lea.l 2*8(a3),a4        two pars required
        cmpa.l a4,a5
        bne.s err_bp

        moveq #2,d1              ensure space for putp
        move.w qa.resri,a2
        jsr (a2)

        moveq #sms.info,d0
        trap #do.smsq           get ptr to system variables in a0

        move.l sys_clnk(a0),d0
        bne.s pi_ok             we have PI

        move.l #$02000100,d4    no PI, use 512x256
        bra.s ret

pi_ok
        movea.l d0,a4           ptr to CON linkage
        move.l pt_xscrs(a4),d4  get scr x/y

ret
        bsr.s putp
        bne.s rts               some error

        addq.l #nt.len,a3       next parameter

*
putp
        swap d4                 start with x%

        moveq #$0f,d0           par type mask
        and.b 1(a6,a3.l),d0     strip par type
        subq.b #3,d0            int?
        beq.s doit               yes, ok

        moveq #0,d0              no, no error,
rts
        rts                       just dont do it

doit
        subq.l #2,sb_arthp(a6)
        movea.l sb_arthp(a6),a1
        move.w d4,(a6,a1.l)
        move.w sb.putp,a2
        jmp (a2)

err_bp
        moveq #err.ipar,d0
        rts

*
        end
